import { Sub } from './cmd';
import { ActionType } from './types';
export declare function inject<S, A>(s?: S, a?: A): dispatcher.InjectContext<S, A>;
export declare namespace dispatcher {
    let getResult: () => {
        state: any;
        cmd: Sub<any>[];
    } | undefined;
    let getContext: () => InjectContext<any, any>;
    type Mapper<A, SubA> = ((a: A) => SubA) | null;
    class CmdHelper<S = any, A = any> {
        readonly setState: (s: Partial<S>) => void;
        private readonly _mapper?;
        none: Sub<any>[];
        constructor(setState: (s: Partial<S>) => void, _mapper?: ((a: any) => A) | null | undefined);
        map<SubA>(mapper: Mapper<A, SubA>): CmdHelper<S, SubA>;
        addSub(...subs: Sub<A>[]): this;
        addBatch(subs: Sub<A>[]): this;
        addFn<Arg, T>(task?: () => T, succeedAction?: ActionType<T, S, A>, failedAction?: ActionType<Error, S, A>): any;
        addPromise<Arg, T>(task: (arg: Arg) => Promise<T>, args: Arg, succeedAction?: ActionType<T, S, A>, failedAction?: ActionType<Error, S, A>): any;
        addPromise<Arg, T>(task: () => Promise<T>, succeedAction?: ActionType<T, S, A>, failedAction?: ActionType<Error, S, A>): any;
        private _addCmd;
    }
    interface ActiveProps {
        state: any;
        actions: any;
        parentState: any;
        parentActions: any;
        setState: (s: any, callback?: any) => any;
    }
    class InjectContext<S, A = any> extends CmdHelper<S, A> {
        state: S;
        actions: A;
        setState: (s: Partial<S>, callback?: () => void) => InjectContext<S, A>;
        parentState: any;
        parentActions: any;
        Cmd: CmdHelper<S, A>;
        constructor(props: ActiveProps, setState: (s: Partial<S>, callback?: () => void) => InjectContext<S, A>);
    }
    function active<S>(props: ActiveProps): void;
    function deactive(): void;
}
