import * as LRUCache from 'lru-cache';
export declare function memoizeBind<A, Res>(callback: (a: A, ...args: any[]) => Res, a: A): (...args: any[]) => Res;
export declare function memoizeBind<A, B, Res>(callback: (a: A, b: B, ...args: any[]) => Res, a: A, b: B): Res;
export declare function memoizeBind<A, B, C, Res>(callback: (a: A, b: B, c: C, ...args: any[]) => Res, a: A, b: B, c: C): (...args: any[]) => Res;
export declare function memoizeBind<A, B, C, D, Res>(callback: (a: A, b: B, c: C, d: D, ...args: any[]) => Res, a: A, b: B, c: C, d: D): (...args: any[]) => Res;
export declare function memoizeBind<A, B, C, D, E, Res>(callback: (a: A, b: B, c: C, d: D, e: E, ...args: any[]) => Res, a: A, b: B, c: C, d: D, e: E): (...args: any[]) => Res;
export declare function memoizeBind<A, B, C, D, E, F, Res>(callback: (a: A, b: B, c: C, d: D, e: E, f: F, ...args: any[]) => Res, a: A, b: B, c: C, d: D, e: E, f: F): (...args: any[]) => Res;
/**
 * memoize stateless component (function component) via only one cache, it works like pure component.
 */
export declare function memoizeOne<P extends object, R>(fn: (props: P) => R, excludes?: string[]): ((props: P) => R);
export declare function setCacheOptions(opts: LRUCache.Options): void;
